## ADFlib-0.9.0.tar.gz

=== CMakeLists.txt ===

cmake_minimum_required ( VERSION 3.11 )

# version details - use utils/bump-version to update it
set ( ADFLIB_VERSION 0.9.0 )
set ( ADFLIB_DATE 2024-05-16 )

project ( adflib
    VERSION      ${ADFLIB_VERSION}
    DESCRIPTION  "A free, portable and open implementation of the Amiga filesystem"
    HOMEPAGE_URL "https://gitlab.com/lclevy/ADFlib"
    LANGUAGES    C
)

message ( STATUS "Building version: ${PROJECT_VERSION}, ${ADFLIB_DATE}" )

set ( CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake )

# setting NDEBUG
# ( https://lists.debian.org/debian-mentors/2018/04/msg00244.html )
#set ( CMAKE_BUILD_TYPE Release )

message ( STATUS "Compiler ID: ${CMAKE_C_COMPILER_ID}" )

add_compile_options (
    -Wall
    $<$<CONFIG:RELEASE>:-O3>
#    -DADFLIB_VERSION="${ADFLIB_VERSION}"
#    -DADFLIB_DATE="${ADFLIB_DATE}"
)

if ( NOT "${CMAKE_C_COMPILER_ID}" STREQUAL "MSVC" )
    message ( STATUS "Setting additional compiler options/checks (mainly for gcc and clang)" )
    add_compile_options (
      -Wextra
      -Wconversion
      -Wsign-conversion
      -pedantic
      -Werror-implicit-function-declaration
      -Werror=format-security
    #  -pedantic-errors
    #  $<$<CONFIG:DEBUG>:-g3>
    #  $<$<CONFIG:DEBUG>:-Og>
      $<$<CONFIG:DEBUG>:-ggdb>
    #  $<$<CONFIG:DEBUG>:-pg>
    )
endif()

if ("${CMAKE_C_COMPILER_ID}" STREQUAL "AppleClang")
    message ( STATUS "Setting additional clang options/checks" )
    add_compile_options (
      -Wno-gnu-statement-expression-from-macro-expansion
    )
endif()

option ( ADFLIB_ENABLE_ADDRESS_SANITIZER "Enable address sanitizer" OFF )

if ( ADFLIB_ENABLE_ADDRESS_SANITIZER )

    if ( "${CMAKE_C_COMPILER_ID}" STREQUAL "GNU" AND NOT MINGW AND NOT CYGWIN )
        message ( STATUS "Enabling GNU address sanitizer" )
        add_compile_options ( -fsanitize=address )
        add_link_options (
            -fsanitize=address
	# for library need either this or LD_PRELOAD (-lasan does not work )
            -static-libasan
	)
    endif()

    if ( MINGW OR CYGWIN )
        message ( STATUS "No address sanitizer for CygWin or MinGW (not available)")
    endif()

    if ( "${CMAKE_C_COMPILER_ID}" MATCHES ".*Clang" )
        message ( STATUS "Enabling Clang address sanitizer" )
        # https://releases.llvm.org/10.0.0/tools/clang/docs/AddressSanitizer.html
        add_compile_options ( -fsanitize=address )
        add_link_options ( -fsanitize=address )
    endif()

    if ( "${CMAKE_C_COMPILER_ID}" STREQUAL "MSVC" )
        # https://learn.microsoft.com/en-us/cpp/sanitizers/asan?view=msvc-170
        message ( STATUS "Enabling MSVC address sanitizer" )
        add_compile_options ( /fsanitize=address /Zi )
        add_link_options ( /fsanitize=address /Zi)
    endif()

else()
    message ( STATUS "Address sanitizer disabled - not configuring" )
endif()

add_compile_definitions ( BUILDING_WITH_CMAKE=1 )

option ( ADFLIB_BUILD_DLL "Build Windows DLL" OFF )
if ( ADFLIB_BUILD_DLL )
#if(BUILD_SHARED_LIBS)
    message ( STATUS "Building a Windows DLL" )
    add_definitions ( -DBUILD_DLL )
endif ( ADFLIB_BUILD_DLL )

include ( CheckFunctionExists )
check_function_exists ( backtrace HAVE_BACKTRACE )
check_function_exists ( backtrace_symbols HAVE_BACKTRACE_SYMBOLS )
#include(CheckCXXSymbolExists)
#check_cxx_symbol_exists(backtrace features HAVE_BACKTRACE)
#check_cxx_symbol_exists(backtrace_symbols features HAVE_BACKTRACE_SYMBOLS)
#message ( STATUS "HAVE_BACKTRACE: ${HAVE_BACKTRACE}" )
#message ( STATUS "HAVE_BACKTRACE_SYMBOLS: ${HAVE_BACKTRACE_SYMBOLS}" )
if ( ${HAVE_BACKTRACE} )
    message ( STATUS "backtrace_symbols() available")
    add_link_options ( $<$<CONFIG:DEBUG>:-rdynamic> ) # for backtrace_symbols()
endif()

include ( CheckSymbolExists )
check_symbol_exists ( strndup "string.h" HAVE_STRNDUP )
if ( ${HAVE_STRNDUP} )
  add_compile_definitions ( HAVE_STRNDUP=1 )
endif()

option ( ADFLIB_ENABLE_NATIVE_DEV "Enable real native devices" OFF )

add_subdirectory ( src )
add_subdirectory ( examples )

option ( ADFLIB_ENABLE_TESTS "Enable tests" ON )
option ( ADFLIB_ENABLE_UNIT_TESTS "Enable units tests (require Check framework >= 0.11" ON )

if ( ADFLIB_ENABLE_TESTS )
    message ( STATUS "Testing enabled" )
    enable_testing()
    add_subdirectory ( regtests/Test )
    if ( ADFLIB_ENABLE_UNIT_TESTS AND
	 NOT ( UNIX AND MINGW ) )       # cannot build tests (ie. Check) cross-compiling
        message ( STATUS "Unit tests (in tests/) enabled." )
        add_subdirectory ( tests )
    else()
        message ( STATUS "Unit tests (in tests/) disabled." )
    endif()
else()
    message ( STATUS "Testing disabled" )
endif()

=== examples/CMakeLists.txt ===

include_directories (
  ${PROJECT_SOURCE_DIR}/src
  ${PROJECT_BINARY_DIR}/src
)


if ( "${CMAKE_C_COMPILER_ID}" STREQUAL "MSVC" )
  set ( ADFLIB_CUSTOM_GETOPT_SRC
    getopt.c
    getopt.h )
else()
  set ( ADFLIB_CUSTOM_GETOPT_SRC "")
endif()

add_executable ( unadf unadf.c )
target_link_libraries ( unadf adf )
set_target_properties ( unadf PROPERTIES
  #  INSTALL_RPATH "${CMAKE_INSTALL_LIBDIR}"
  INSTALL_RPATH "/usr/local/lib"
)

add_executable ( adf_floppy_create adf_floppy_create.c )
target_link_libraries ( adf_floppy_create adf )
set_target_properties ( adf_floppy_create PROPERTIES
  INSTALL_RPATH "/usr/local/lib"
)

add_executable ( adf_format
  adf_format.c
  ${ADFLIB_CUSTOM_GETOPT_SRC}
)
target_link_libraries ( adf_format adf )
set_target_properties ( adf_format PROPERTIES
  INSTALL_RPATH "/usr/local/lib"
)

add_executable ( adf_show_metadata
  adf_show_metadata.c
  adf_show_metadata_common.c
  adf_show_metadata_common.h
  adf_show_metadata_dir.c
  adf_show_metadata_dir.h
  adf_show_metadata_file.c
  adf_show_metadata_file.h
  adf_show_metadata_volume.c
  adf_show_metadata_volume.h
)
target_link_libraries ( adf_show_metadata adf )
set_target_properties ( adf_show_metadata PROPERTIES
  INSTALL_RPATH "/usr/local/lib"
)

add_executable ( adf_bitmap adf_bitmap.c )
target_link_libraries ( adf_bitmap adf )
set_target_properties ( adf_bitmap PROPERTIES
  INSTALL_RPATH "/usr/local/lib"
)

add_executable ( adf_salvage
  adf_salvage.c
  ${ADFLIB_CUSTOM_GETOPT_SRC}
)
target_link_libraries ( adf_salvage adf )
set_target_properties ( adf_salvage PROPERTIES
  INSTALL_RPATH "/usr/local/lib"
)

file (
  COPY ${PROJECT_SOURCE_DIR}/examples/tests
  DESTINATION ${PROJECT_BINARY_DIR}/examples/
)

if ( ADFLIB_ENABLE_TESTS )
    message ( STATUS "Enable tests in examples/" )
    add_test ( tests/test_examples_basic.sh ${BASH_PROGRAM}
               tests/test_examples_basic.sh . )
    add_test ( tests/adf-floppy-test.sh ${BASH_PROGRAM}
               tests/adf-floppy-test.sh )
    add_test ( tests/adf-show-metadata-test.sh ${BASH_PROGRAM}
               tests/adf-show-metadata-test.sh )
    add_test ( tests/unadf-test.sh ${BASH_PROGRAM}
               tests/unadf-test.sh )
endif()

install ( TARGETS
  unadf
  adf_floppy_create
  adf_format
  adf_show_metadata
  adf_bitmap
  adf_salvage
)

=== src/CMakeLists.txt ===

# set DLL symbols export (if building a DLL)
if ( ADFLIB_BUILD_DLL )
    message ( STATUS "Exporting DLL symbols." )
    add_compile_definitions ( _EXPORTING )
endif ( ADFLIB_BUILD_DLL )

if ( ADFLIB_ENABLE_NATIVE_DEV )
# Useful info (note that CYGWIN went from WIN32 to UNIX...):
# https://gitlab.kitware.com/cmake/community/-/wikis/doc/tutorials/How-To-Write-Platform-Checks
    if ( WIN32 OR CYGWIN OR MINGW OR MSYS OR CMAKE_C_PLATFORM_ID STREQUAL "MinGW")
        set ( ADFLIB_NATIVE_DEV_DIR win32 )
        set ( ADFLIB_NATIVE_DEV_SRC
              win32/adf_dev_driver_nativ.c
              win32/nt4_dev.c
              win32/nt4_dev.h )
    else()
        if ( UNIX AND CMAKE_SYSTEM_NAME STREQUAL "Linux" )
	    set ( ADFLIB_NATIVE_DEV_DIR linux )
            set ( ADFLIB_NATIVE_DEV_SRC linux/adf_dev_driver_nativ.c )
        else()
            set ( ADFLIB_NATIVE_DEV_DIR generic )
            set ( ADFLIB_NATIVE_DEV_SRC generic/adf_dev_driver_nativ.c )
        endif()
    endif()
else()
    set ( ADFLIB_NATIVE_DEV_DIR generic )
    set ( ADFLIB_NATIVE_DEV_SRC generic/adf_dev_driver_nativ.c )
endif()
message ( STATUS "Native device directory: ${ADFLIB_NATIVE_DEV_DIR}" )
message ( STATUS "Native device sources:   ${ADFLIB_NATIVE_DEV_SRC}" )

include_directories (
  ${PROJECT_SOURCE_DIR}/src
  ${ADFLIB_NATIVE_DEV_DIR}
  ${PROJECT_BINARY_DIR}/src
)

if ( CMAKE_BUILD_TYPE MATCHES DEBUG )
    message ( STATUS "Debug mode - building with debug_utils")
    set ( ADFLIB_DEBUG_MODULES debug_util.c debug_util.h )
endif ( CMAKE_BUILD_TYPE MATCHES DEBUG )


add_library ( adf
  adflib.h
  adf_bitm.c
  adf_bitm.h
  adf_blk.h
  adf_blk_hd.h
  adf_byteorder.h
  adf_cache.c
  adf_cache.h
  adf_dev.c
  adf_dev_driver.h
  adf_dev_driver_dump.c
  adf_dev_driver_dump.h
  adf_dev_driver_ramdisk.c
  adf_dev_driver_ramdisk.h
  adf_dev_drivers.c
  adf_dev_drivers.h
  adf_dev_flop.c
  adf_dev_flop.h
  adf_dev.h
  adf_dev_hd.c
  adf_dev_hd.h
  adf_dir.c
  adf_dir.h
  adf_env.c
  adf_env.h
  adf_err.h
  adf_file_block.c
  adf_file_block.h
  adf_file.c
  adf_file.h
  adf_file_util.h
  adf_link.c
  adf_link.h
  adf_prefix.h
  adf_raw.c
  adf_raw.h
  adf_salv.c
  adf_salv.h
  adf_str.c
  adf_str.h
  adf_types.h
  adf_util.c
  adf_util.h
  adf_version.h
  adf_vol.c
  adf_vol.h
  adf_dev_driver_nativ.h
  ${ADFLIB_NATIVE_DEV_SRC}
  ${ADFLIB_DEBUG_MODULES}
)

set_target_properties ( adf PROPERTIES
    #PUBLIC_HEADER "adflib.h"
    PUBLIC_HEADER "adflib.h;adf_bitm.h;adf_blk.h;adf_blk_hd.h;adf_cache.h;adf_dev_driver_dump.h;adf_dev_driver_nativ.h;adf_dev_driver_ramdisk.h;adf_dev_flop.h;adf_dev.h;adf_dev_hd.h;adf_dir.h;adf_env.h;adf_err.h;adf_file_block.h;adf_file.h;adf_file_util.h;adf_prefix.h;adf_raw.h;adf_salv.h;adf_str.h;adf_types.h;adf_version.h;adf_vol.h"
    PRIVATE_HEADER "adf_byteorder.h;adf_link.h;adf_util.h;debug_util.h"
    VERSION ${CMAKE_PROJECT_VERSION}
#    SOVERSION ${PROJECT_VERSION_MAJOR}
    SOVERSION 1
)

target_include_directories ( adf
    PUBLIC
        "${CMAKE_CURRENT_SOURCE_DIR}"
    PRIVATE
        "${CMAKE_CURRENT_SOURCE_DIR}"
)

#target_link_libraries ( adf ${SOME_LIBRARIES} )

if (APPLE)
    set ( ADFLIB_INSTALL_INCLUDE_DIR /usr/local/include )
else()
    set ( ADFLIB_INSTALL_INCLUDE_DIR "${CMAKE_INSTALL_INCLUDEDIR}" )
endif()

install ( TARGETS adf
  LIBRARY
    DESTINATION "${CMAKE_INSTALL_LIBDIR}"
  PUBLIC_HEADER
    DESTINATION "${ADFLIB_INSTALL_INCLUDE_DIR}/adf"
  PRIVATE_HEADER
#    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/adf"
    DESTINATION FALSE
)


# Cmake debugging - list all defined variables
# (from: https://stackoverflow.com/questions/9298278/cmake-print-out-all-accessible-variables-in-a-script )
#get_cmake_property(_variableNames VARIABLES)
#list (SORT _variableNames)
#foreach (_variableName ${_variableNames})
#    message(STATUS "${_variableName}=${${_variableName}}")
#endforeach()

=== tests/CMakeLists.txt ===

find_package ( CHECK 0.11.0 QUIET )
if ( NOT CHECK_FOUND )
    find_package ( PkgConfig QUIET )
    if ( PkgConfig_FOUND )
        set ( PKG_CONFIG_USE_CMAKE_PREFIX_PATH ON )
        pkg_check_modules ( CHECK check>=0.11.0 )
    endif (PkgConfig_FOUND)
endif ( NOT CHECK_FOUND )

if ( NOT CHECK_FOUND )
    # Automatic fetching external dependency
    # ( https://cmake.org/cmake/help/latest/module/FetchContent.html
    #   https://cmake.org/cmake/help/latest/guide/using-dependencies/ )
    message ( STATUS "Fetching Check library" )
    include ( FetchContent )
    FetchContent_Declare (
      CHECK
      GIT_REPOSITORY https://github.com/libcheck/check.git
      GIT_TAG        0.15.2
    )
    FetchContent_MakeAvailable ( CHECK )
endif()

#if (NOT Check_FOUND AND NOT DEFINED Check_QUIET)
#    message(FATAL_ERROR "Could NOT find Check")
#endif (NOT Check_FOUND AND NOT DEFINED Check_QUIET)

#add_compile_options(-pthread)

include_directories ( ${PROJECT_SOURCE_DIR}/src )
include_directories ( ${PROJECT_BINARY_DIR}/src )

message ( STATUS "Check CFLAGS: ${CHECK_CFLAGS}" )
message ( STATUS "Check LDFLAGS: ${CHECK_LDFLAGS}" )
#message ( STATUS "Check include dir: ${CHECK_INCLUDE_DIR}, libraries: ${CHECK_LIBRARIES}")
#if ("${CMAKE_C_COMPILER_ID}" STREQUAL "MSVC")
#include_directories(${CHECK_INCLUDE_DIR})
#else()
add_compile_options ( ${CHECK_CFLAGS} )
#endif()

add_executable ( test_test_util
                 test_test_util.c
                 test_util.c )

add_executable ( test_adfPos2DataBlock
                 test_adfPos2DataBlock.c )

add_executable ( test_adfDays2Date
                 test_adfDays2Date.c
                  ${PROJECT_SOURCE_DIR}/src/adf_util.c
                )

add_executable ( test_dev_open
                 test_dev_open.c )

add_executable ( test_dev_mount
                 test_dev_mount.c )

add_executable ( test_adf_file_util
                 test_adf_file_util.c )

add_executable ( test_file_create
                 test_file_create.c )

add_executable ( test_file_append
                 test_file_append.c )

add_executable ( test_file_write
                 test_file_write.c
	         test_util.c )

add_executable ( test_file_write_chunks
                 test_file_write_chunks.c
	         test_util.c )

add_executable ( test_file_overwrite
                 test_file_overwrite.c )

add_executable ( test_file_overwrite2
                 test_file_overwrite2.c
                 test_util.c )

add_executable ( test_file_seek
                 test_file_seek.c
                 test_util.c )

add_executable ( test_file_seek_after_write
                 test_file_seek_after_write.c
                 test_util.c )

add_executable ( test_file_truncate
                 test_file_truncate.c
                 test_util.c )

add_executable ( test_file_truncate2
                 test_file_truncate2.c
                 test_util.c )

if ( "${CHECK_LIBRARIES}" STREQUAL "" )
  set (CHECK_LIBRARIES Check::check)
else()
  #set (CHECK_LIBRARIES "${CHECK_LIBRARIES} -pthread")
  set (CHECK_LIBRARIES "${CHECK_LDFLAGS}")
endif()

target_link_libraries ( test_test_util PUBLIC
  adf ${CHECK_LIBRARIES}
)

target_link_libraries ( test_adfPos2DataBlock PUBLIC
  adf
  ${CHECK_LIBRARIES}
)

target_link_libraries ( test_adfDays2Date PUBLIC
#  adf
  ${CHECK_LIBRARIES}
)

target_link_libraries ( test_dev_open PUBLIC
  adf
  ${CHECK_LIBRARIES}
)

target_link_libraries ( test_dev_mount PUBLIC
  adf
  ${CHECK_LIBRARIES}
)

target_link_libraries ( test_adf_file_util PUBLIC
  ${CHECK_LIBRARIES}
)


target_link_libraries ( test_file_create PUBLIC
  adf ${CHECK_LIBRARIES}
)

target_link_libraries ( test_file_append PUBLIC
  adf ${CHECK_LIBRARIES}
)

target_link_libraries ( test_file_write PUBLIC
  adf ${CHECK_LIBRARIES}
)

target_link_libraries ( test_file_write_chunks PUBLIC
  adf ${CHECK_LIBRARIES}
)

target_link_libraries ( test_file_overwrite PUBLIC
  adf ${CHECK_LIBRARIES}
)

target_link_libraries ( test_file_overwrite2 PUBLIC
  adf ${CHECK_LIBRARIES}
)

target_link_libraries ( test_file_seek PUBLIC
  adf ${CHECK_LIBRARIES}
)
target_link_libraries ( test_file_seek_after_write PUBLIC
  adf ${CHECK_LIBRARIES}
)

target_link_libraries ( test_file_truncate PUBLIC
  adf ${CHECK_LIBRARIES}
)

target_link_libraries ( test_file_truncate2 PUBLIC
  adf ${CHECK_LIBRARIES}
)

add_test ( test_test_util test_test_util )
add_test ( test_adfPos2DataBlock test_adfPos2DataBlock )
add_test ( test_adfDays2Date test_adfDays2Date )
add_test ( test_dev_open test_dev_open )
add_test ( test_dev_mount test_dev_mount )
add_test ( test_adf_file_util test_adf_file_util )
add_test ( test_file_create test_file_create )
add_test ( test_file_append test_file_append )
add_test ( test_file_write test_file_write )
add_test ( test_file_write_chunks test_file_write_chunks )
add_test ( test_file_overwrite test_file_overwrite )
add_test ( test_file_overwrite2 test_file_overwrite2 )
add_test ( test_file_seek test_file_seek )
add_test ( test_file_seek_after_write test_file_seek_after_write )
add_test ( test_file_truncate test_file_truncate )
add_test ( test_file_truncate2 test_file_truncate2 )

=== regtests/Test/CMakeLists.txt ===

#
# Test building configuration
#

find_program (BASH_PROGRAM bash)

include_directories (
  ${PROJECT_SOURCE_DIR}/src
  ${PROJECT_SOURCE_DIR}/src/generic
  ${PROJECT_BINARY_DIR}/src
)

add_executable ( fl_test fl_test.c )
TARGET_LINK_LIBRARIES ( fl_test adf )

add_executable ( fl_test2 fl_test2.c )
TARGET_LINK_LIBRARIES ( fl_test2 adf )

add_executable ( dir_test dir_test.c )
TARGET_LINK_LIBRARIES ( dir_test adf )

add_executable ( dir_test2 dir_test2.c )
TARGET_LINK_LIBRARIES ( dir_test2 adf )

add_executable ( dir_test_chdir dir_test_chdir.c )
TARGET_LINK_LIBRARIES ( dir_test_chdir adf )

add_executable ( hd_test hd_test.c )
TARGET_LINK_LIBRARIES ( hd_test adf )

add_executable ( hd_test2 hd_test2.c )
TARGET_LINK_LIBRARIES ( hd_test2 adf )

add_executable ( hd_test3 hd_test3.c )
TARGET_LINK_LIBRARIES ( hd_test3 adf )

add_executable ( file_test file_test.c )
TARGET_LINK_LIBRARIES ( file_test adf )

add_executable ( file_test2 file_test2.c )
TARGET_LINK_LIBRARIES ( file_test2 adf )

add_executable ( file_test3 file_test3.c )
TARGET_LINK_LIBRARIES ( file_test3 adf )

add_executable ( file_seek_test file_seek_test.c )
TARGET_LINK_LIBRARIES ( file_seek_test adf )

add_executable ( file_seek_test2 file_seek_test2.c )
TARGET_LINK_LIBRARIES ( file_seek_test2 adf )

add_executable ( file_seek_after_write file_seek_after_write.c )
TARGET_LINK_LIBRARIES ( file_seek_after_write adf )

add_executable ( file_read_hard_link_test file_read_hard_link_test.c )
TARGET_LINK_LIBRARIES ( file_read_hard_link_test adf )

add_executable ( del_test del_test.c )
TARGET_LINK_LIBRARIES ( del_test adf )

add_executable ( bootdisk bootdisk.c )
TARGET_LINK_LIBRARIES ( bootdisk adf )

add_executable ( cache_crash cache_crash.c )
TARGET_LINK_LIBRARIES ( cache_crash adf )

add_executable ( rename rename.c )
TARGET_LINK_LIBRARIES ( rename adf )

add_executable ( hardfile hardfile.c )
TARGET_LINK_LIBRARIES ( hardfile adf )

add_executable ( hardfile2 hardfile2.c )
TARGET_LINK_LIBRARIES ( hardfile2 adf )

add_executable ( rename2 rename2.c )
TARGET_LINK_LIBRARIES ( rename2 adf )

add_executable ( access access.c )
TARGET_LINK_LIBRARIES ( access adf )

add_executable ( comment comment.c )
TARGET_LINK_LIBRARIES ( comment adf )

add_executable ( undel undel.c )
TARGET_LINK_LIBRARIES ( undel adf )

add_executable ( readonly readonly.c )
TARGET_LINK_LIBRARIES ( readonly adf )

add_executable ( undel2 undel2.c )
TARGET_LINK_LIBRARIES ( undel2 adf )

add_executable ( dispsect dispsect.c )
TARGET_LINK_LIBRARIES ( dispsect adf )

add_executable ( progbar progbar.c )
TARGET_LINK_LIBRARIES ( progbar adf )

add_executable ( floppy_overfilling_test floppy_overfilling_test.c )
TARGET_LINK_LIBRARIES ( floppy_overfilling_test adf )

add_executable ( bitmap_read_segfault bitmap_read_segfault.c )
TARGET_LINK_LIBRARIES ( bitmap_read_segfault adf )

add_executable ( bitmap_recreate bitmap_recreate.c )
TARGET_LINK_LIBRARIES ( bitmap_recreate adf )


foreach ( a_file
    floppy.sh
    bigdev.sh
    bootdisk.sh
    bitmap_read_segfault.sh
    bitmap_recreate.sh
    cache_crash.sh
    common.sh
    del_test.sh
    dir_test2.sh
    dir_test_chdir.sh
    dir_test.sh
    file_read_hard_link_test.sh
    file_seek_test2.sh
    file_seek_test.sh
    file_test2.sh
    file_test3.sh
    file_test.sh
    floppy_overfilling_test.sh
    floppy.sh
    fl_test2.sh
    fl_test.sh
    hardfile.sh
    hd_test2.sh
    hd_test3.sh
    hd_test.sh
    rename2.sh
    rename.sh
    undel2.sh
    undel.sh )
  configure_file ( ${a_file} ${a_file} COPYONLY )
endforeach ( a_file )

file (
  COPY ${PROJECT_SOURCE_DIR}/regtests/Boot
  DESTINATION ${PROJECT_BINARY_DIR}/regtests/
)

file (
  COPY ${PROJECT_SOURCE_DIR}/regtests/Dumps
  DESTINATION ${PROJECT_BINARY_DIR}/regtests/
)

file (
  COPY ${PROJECT_SOURCE_DIR}/regtests/Files
  DESTINATION ${PROJECT_BINARY_DIR}/regtests/
)


#
# Test executing configuration
#

add_test ( floppy.sh ${BASH_PROGRAM} floppy.sh )
add_test ( bigdev.sh ${BASH_PROGRAM} bigdev.sh )

=== packaging/debian/changelog ===
adflib (0.9.0-1) unstable; urgency=medium

  * Library license changed to dual license (GPL2 and LGPL2.1).
  * Many changes in the API (refactoring, renaming etc.).
  * Improved support of block allocation bitmap (checking and reconstruction).
  * Improved device API (added ramdisk and a possibility to implement others).
  * Improved salvage, added an utility for undeleting files (EXPERIMENTAL!).
  * Bugfixes: bitmap, memory leaks and others (more in ChangeLog and git log).

 -- Tomasz Wolak <tomas.wolak@gmail.com>  Thu, 16 May 2024 17:19:35 +0100

adflib (0.8.0-1) unstable; urgency=medium

  * Initial packaging of version 0.8.0 for Debian.

 -- Tomasz Wolak <tomas.wolak@gmail.com>  Mon, 26 Jun 2023 20:01:05 +0100

=== packaging/debian/control ===
Source: adflib
Section: libs
Priority: optional
Maintainer: Tomasz Wolak <tomas.wolak@gmail.com>
Uploaders: Gürkan Myczko <tar@debian.org>
Build-Depends: dh-autoreconf,
               debhelper-compat (= 13),
               autotools-dev
Standards-Version: 4.6.2
Homepage: https://github.com/lclevy/ADFlib
Vcs-Git: https://salsa.debian.org/debian/unadf.git
Vcs-Browser: https://salsa.debian.org/debian/unadf

Package: libadf
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ADFlib - shared library.
 This is a a free, portable and open implementation of the Amiga filesystem.
 .
 This package contains the shared library.

Package: libadf-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libadf (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ADFlib - development files
 This is a a free, portable and open implementation of the Amiga filesystem.
 .
 This package contains the development files.

Package: libadf-utils
Architecture: any
Multi-Arch: no
Section: utils
Depends: libadf (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: Utilities for Amiga disk image files (ADF).
 Utilities for ADF disk images:
 .
 adf_bitmap        - show or reconstruct volume's block allocation bitmap
 adf_floppy_create - create a new floppy disk image file
 adf_format        - format a volume of an ADF device
 adf_salvage       - show or recover/extract deleted files
 adf_show_metadata - display low-level info about a device/adf file
                     or a file/directory

Package: unadf
Architecture: any
Multi-Arch: no
Section: utils
Depends: libadf (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: Extract files from an Amiga Disk File dump (.adf)
 Tool for extracting and listing files in an Amiga Disk File.
 .
 Amiga Disk File aka ADF is a file format used by Amiga computers and emulators
 to store images of disks. ADF is not really a file format but actually a
 track-by-track dump of the disk data as read by the Amiga operating system,
 and so the "format" is really fixed-width AmigaDOS data tracks appended one
 after another and held in a file.

=== packaging/debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
#	dh $@ --parallel
#	dh $@ --parallel --with autotools_dev
	dh $@ --with autoreconf

#override_dh_auto_configure:
#	dh_auto_configure -- --enable-native-generic

=== packaging/debian/watch ===
version=4
https://github.com/lclevy/ADFlib.git refs/tags/v([\d\.]+)
